﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: color, DefaultValue: 0xFFFFFFFF
#DesignerProperty: Key: PreviewButtonColor, DisplayName: Preview Button Color, FieldType: color, DefaultValue: 0xFFFFFFFF
#DesignerProperty: Key: UnreadBackgroundColor, DisplayName: Unread Message Background Color, FieldType: color, DefaultValue: 0xFF7DBDF2
#DesignerProperty: Key: UnreadTextColor, DisplayName: Unread Text Color, FieldType: color, DefaultValue: 0xFF7DBDF2
#DesignerProperty: Key: LeftBurgerVisible, DisplayName: Left Burger Visible, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: RightBurgerVisible, DisplayName: Right Burger Visible, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: DateAndTimeFormat, DisplayName: Date & Time format, FieldType: String, DefaultValue: dd-MM-yyyy HH:mm:ss
#DesignerProperty: Key: CornerRadius, DisplayName: Corner Radius, FieldType: Int, DefaultValue: 0, MinRange: 0, MaxRange: 255, Description: 
#DesignerProperty: Key: UnreadCornerRadius, DisplayName: Unread Corner Radius, FieldType: Int, DefaultValue: 0, MinRange: 0, MaxRange: 255, Description: 
#DesignerProperty: Key: UnreadBorderThickness, DisplayName: Unread Border Thickness, FieldType: Int, DefaultValue: 0, MinRange: 0, MaxRange: 255, Description: 
#DesignerProperty: Key: AnimationSpeed, DisplayName: Animation Speed, FieldType: Int, DefaultValue: 300, MinRange: 0, MaxRange: 1000 , Description: 
#DesignerProperty: Key: DividerHeight, DisplayName: Divider Height, FieldType: Int, DefaultValue: 1, MinRange: 1, Description: Gap between messages.
'#DesignerProperty: Key: DateOnlyFormat, DisplayName: Date only format, FieldType: String, DefaultValue: dd-MM-yyyy
#DesignerProperty: Key: MainBorderWidth, DisplayName: Main Border Width, FieldType: Int, DefaultValue: 1, MinRange: 1, Description: Main Border width
#DesignerProperty: Key: SneakPreview , DisplayName: Sneak Preview, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: BurgerColor, DisplayName: Burger Color, FieldType: String, DefaultValue: Black, List: Black|Blue|Cyan|Green|Red|White
#DesignerProperty: Key: HeadingText, DisplayName: HeadingText, FieldType: String , DefaultValue:

#Event: PreviewConversation (conv as convoEntry)
#Event: OpenConversation (conv as convoEntry)

Sub Class_Globals
	
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object

	Type convoEntry (id As String, WithWho As String, dt As Long, UnreadCount As Int)

	Private lblConvoWith 									As B4XView
	Private lblLastDate 									As B4XView
	Private lblUnreadCount 									As B4XView
	
	Private clvMain 										As CustomListView
	
	Private idx												As Int
	
	Private mTextColor 										As Int
	Private mBackgroundColor 								As Int
'	Private mPreviewButtonColor 							As Int
	Private mUnreadBackgroundColor 							As Int
	Private mUnreadTextColor 								As Int
	Private mUnreadBorderThickness							As Int
	Private mLeftBurgerVisible 								As Boolean
	Private mRightBurgerVisible 							As Boolean
	Private mDateAndTimeFormat 								As String
	Private mCornerRadius 									As Int
	Private mMainBorderWidth								As Int
	Private mUnreadCornerRadius								As Int
	Private ivLeftBurger 									As B4XView
	Private ivRightBurger 									As B4XView
	Private mSneakPreview									As Boolean
	Private mBurgerColor									As String
	
	Private lblPreview As B4XView
	Private pnlMain As B4XView
	Private lblHeadingText As B4XView
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	'Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props

	Sleep (0)
	mBase.LoadLayout ("clvConvoList")

	mTextColor = Props.Get("TextColor")
	mBackgroundColor = Props.Get("BackgroundColor")
'	mPreviewButtonColor = Props.Get("PreviewButtonColor")
	mUnreadBackgroundColor = Props.Get("UnreadBackgroundColor")
	mUnreadTextColor = Props.Get("UnreadTextColor")
	mLeftBurgerVisible = Props.Get("LeftBurgerVisible")
	mRightBurgerVisible = Props.Get("RightBurgerVisible")
	mDateAndTimeFormat = Props.Get("DateAndTimeFormat")
	mCornerRadius = Props.Get("CornerRadius") * 1dip
	mMainBorderWidth = Props.Get ("ChatWithBorderWidth")
	mUnreadCornerRadius = Props.Get ("UnreadCornerRadius") * 1dip
	mUnreadBorderThickness = Props.Get ("UnreadBorderThickness")
	mSneakPreview = Props.Get ("SneakPreview")
	mBurgerColor = Props.get ("BurgerColor")
	
	mBase.Color = mBackgroundColor
	
	DateTime.DateFormat = mDateAndTimeFormat
	ivLeftBurger.Visible = mLeftBurgerVisible
	ivRightBurger.Visible = mRightBurgerVisible
	
	Dim burg As B4XBitmap = LoadBitmap (File.DirAssets, "hamburger" & mBurgerColor & ".png")
	ivLeftBurger.SetBitmap (burg)
	ivRightBurger.Setbitmap (burg)
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
End Sub

public Sub UpdateConvo (id As String, WithWho As String, dt As Long, UnreadCount As Int) As Boolean

	Dim found As Boolean = False
	Dim foundID As Int
		
	Dim x As Int
	For x = 0 To clvMain.Size -1
		Dim c As convoEntry = clvMain.GetValue (x)
		
		If c.id = id Then			'Got a match so let's update this one!
			If WithWho <> "" Then c.WithWho = WithWho Else WithWho = c.WithWho
			If dt <> 0 Then c.dt = dt Else dt = c.dt
			If UnreadCount >= 0 Then c.UnreadCount = UnreadCount Else UnreadCount = c.UnreadCount
			
			found = True
			foundID = x
		End If
	Next

	If found = False Then
		'Couldn't find an entry so add it instead
		AddConvo (id, WithWho, dt, UnreadCount)
		ReorderCLV
		Return False
	End If

	'Found an entry, so update it
	Dim m As Map = GeneratePanel (id, WithWho, dt, UnreadCount)
	Dim p As Panel = m.Get ("convo")
	clvMain.ReplaceAt (foundID, p ,p.Height, m.Get ("data"))

	'The actual update is done, but we should now reorder the list in date/time order
	
	ReorderCLV
	
	Return True
	
End Sub

Private Sub AddConvo (id As String, WithWho As String, dt As Long, UnreadCount As Int)
	Dim m As Map = GeneratePanel (id, WithWho, dt, UnreadCount)
	clvMain.Add (m.get ("convo"), m.get ("data"))
	idx = idx +1
End Sub

Private Sub GeneratePanel (id As String, WithWho As String, dt As Long, UnreadCount As Int) As Map
	
	Dim m As Map
	m.Initialize
	
	Dim p As Panel = xui.CreatePanel ("")
	
	#if b4a
	p.SetLayoutAnimated (0, 0, 0, mBase.Width, 55dip)
	#else
	p.SetLayoutAnimated (0, 0.1, 0, 0, mBase.Width, 55dip)
	#End If
	
	p.LoadLayout ("ConvoPanel")
	
	Dim c As convoEntry
	c.Initialize
	c.id = id
	c.WithWho = WithWho
	c.UnreadCount = UnreadCount
	c.dt = dt
	
	If UnreadCount = 0 Then
		lblPreview.Visible = False
		lblUnreadCount.Visible = False
		lblPreview.Visible = False
	Else
		lblPreview.Visible = True
		lblUnreadCount.Visible = True
		lblPreview.Visible = mSneakPreview
	End If
	lblPreview.Tag = idx
	lblConvoWith.Text = "  " & WithWho
	lblConvoWith.Tag = idx
	lblLastDate.Text = "  " & DateTime.Date (dt)
	
	p.Color = mBackgroundColor
	pnlMain.SetColorAndBorder (mBackgroundColor, mMainBorderWidth, mTextColor, mCornerRadius)
	lblConvoWith.TextColor = mTextColor
	lblLastDate.SetColorAndBorder (mBackgroundColor, 0 , mTextColor, 0)
	lblLastDate.TextColor = mTextColor
	
'	#if b4i
'		Dim no As NativeObject = lblUnreadCount
'		no.GetField ("layer").SetField ("maskedCorners", 1 + 2 + 4 + 8)
'	#End If

	lblUnreadCount.as(B4XView).SetColorAndBorder (mUnreadBackgroundColor, mUnreadBorderThickness, mUnreadTextColor, mUnreadCornerRadius)
	lblUnreadCount.TextColor = mUnreadTextColor

	If UnreadCount > 9 Then lblUnreadCount.Text = "9+" Else lblUnreadCount.Text = UnreadCount
	
	m.Put ("convo", p)
	m.Put ("data", c)
	
	Return m
End Sub

Private Sub lblConvoWith_Click
	'Send instruction to open the relevant conversation
	
	Dim lbl As B4XView = Sender

	Dim c As convoEntry
	c.Initialize
	c = GetConvoDetails (lbl.Tag)
	Log (c.WithWho)
	
	If xui.SubExists(mCallBack, mEventName & "_OpenConversation", 0) Then
		CallSub2(mCallBack, mEventName & "_OpenConversation", c)
	End If

End Sub

Private Sub lblPreview_Click
	'Send instruction preview relevant unread messages
	
	Dim lbl As B4XView = Sender

	Dim c As convoEntry
	c.Initialize
	c = GetConvoDetails (lbl.Tag)
	Log (c.WithWho)
	
	If xui.SubExists(mCallBack, mEventName & "_PreviewConversation", 0) Then
		CallSub2(mCallBack, mEventName & "_PreviewConversation", c)
	End If

End Sub

Private Sub clvMain_ItemClick (Index As Int, Value As Object)

	Dim c As convoEntry
	c.Initialize
	c = GetConvoDetails (Index)
	
	Log (c.WithWho)
	
	If xui.SubExists(mCallBack, mEventName & "_OpenConversation", 0) Then
		CallSub2(mCallBack, mEventName & "_OpenConversation", c)
	End If

End Sub

private Sub GetConvoDetails (i As Int) As convoEntry
	Return (clvMain.getvalue (i))
End Sub

'Reorder the CLV into date & time order. Newest at the top. We could just redraw the lot but that would look crap on screen
'so we will do more subtle moves

Private Sub ReorderCLV
	
	Dim x,y As Int
	Dim MovedSomething As Boolean = False
		
	'First let's move the panels
	For x = 0 To clvMain.Size -1
		Dim p As Panel = clvMain.GetPanel (x)
		Dim c As convoEntry = clvMain.GetValue (x)
		
		For y = 0 To clvMain.Size -1
			Dim c2 As convoEntry = clvMain.GetValue (y)
			
			If c2.dt > c.dt And y >= x Then		'We have an item to move
				clvMain.RemoveAt (y)
				
				Dim m As Map = GeneratePanel (c2.id, c2.WithWho, c2.dt, c2.UnreadCount)
				clvMain.InsertAt (x, m.Get ("convo"), m.Get ("data"))
				MovedSomething = True
			End If
		Next
	Next
	
	'If something has been moved then the list indexes need to be reordered too
	
	If MovedSomething Then
		idx = 0
	
		For x = 0 To clvMain.Size -1
			Dim p As Panel = clvMain.GetPanel (x)
			Dim c As convoEntry = clvMain.GetValue (x)

			p.Tag = x
		
			Dim lblp, lblc As B4XView
			Dim p2 As Panel
		
			p2 = p.GetView (0)				'Get the first panel in the view
		
			lblc = p2.GetView (0)
			lblp = p2.GetView (0)
		
			lblc.Tag = x
			lblp.Tag = x
		Next
	End If
End Sub

Public Sub setLeftBurgerVisible (visible As Boolean)
	mLeftBurgerVisible = visible
	ivLeftBurger.Visible = mLeftBurgerVisible
End Sub

Public Sub getLeftBurgerVisible As Boolean
	Return mLeftBurgerVisible
End Sub

Public Sub setRightBurgerVisible (visible As Boolean)
	mRightBurgerVisible = visible
	ivRightBurger.Visible = mLeftBurgerVisible
End Sub

Public Sub getRightBurgerVisible As Boolean
	Return mRightBurgerVisible
End Sub

public Sub setSneakPreviewVisible (visible As Boolean)
	mSneakPreview = visible
	lblPreview.Visible = visible
End Sub

public Sub getSneakPreviewVisible As Boolean
	Return mSneakPreview
End Sub